"""
         Version 1.4.0
         *** added second argument for level-tabulation
         *** added level as optional argument, to make both APIs compatible
         *** added the bool argument to make changes optional
         *** added the output argument with sys.stdout as default
This is a test MODULE named flatt.py, uploaded with any
DISTRIBUTION UTILITY, to the PyPI THIRD-PARTY REPOSITORY
It contains only one function, flatprint.
"""
# movies_ex = ["grail", "1975", "jones&gilliam", "91",
#              ["chapman", ["palin", "cleese", "gilliam", "idle", "jones"]]]
# flatprint(movies_ex)

import sys

def flatprint (lst,indent=False,level=0,output=sys.stdout):
    """version 1.4.0 of the recursive function, given a nested list (tree)
       prints all sheets, tabulated in relation to their deepness. Arguments:
          -lst: any nested list
          -indent: boolean, switches indentation on/off. Off by default
          -level: starting point for indentation. 0 by default
          -output: the adress where the print BIF sends the stream to."""    
    for elt in lst:
        if isinstance(elt,list):
            flatprint(elt, indent, level+1, output)
        else:
            if indent:
                for i in range(level):
                    print("\t", end='', file=output)
            print(elt, file=output)
